#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Windows.Forms;
using HeuristicLab.MainForm;
using HeuristicLab.MainForm.WindowsForms;

namespace HeuristicLab.Clients.OKB {
  [View("OKB Administrator")]
  [Content(typeof(Administrator), true)]
  public sealed partial class AdministratorView : AsynchronousContentView {
    public new Administrator Content {
      get { return (Administrator)base.Content; }
      set { base.Content = value; }
    }

    public AdministratorView() {
      InitializeComponent();
    }

    protected override void DeregisterContentEvents() {
      // ...
      base.DeregisterContentEvents();
    }
    protected override void RegisterContentEvents() {
      base.RegisterContentEvents();
      // ...
    }

    protected override void OnContentChanged() {
      base.OnContentChanged();
      if (Content == null) {
        algorithmClassCollectionView.Content = null;
        algorithmCollectionView.Content = null;
      } else {
        algorithmClassCollectionView.Content = Content.AlgorithmClasses;
        algorithmCollectionView.Content = Content.Algorithms;
      }
    }

    protected override void SetEnabledStateOfControls() {
      base.SetEnabledStateOfControls();
      refreshButton.Enabled = Content != null;
      algorithmClassCollectionView.Enabled = Content != null;
      algorithmCollectionView.Enabled = Content != null;
    }

    private void refreshButton_Click(object sender, EventArgs e) {
      Content.Refresh();
    }
  }
}
